#! /usr/local/bin python
import sys
import argparse
import time
from pprint import pprint
import xmltodict
from lxml import etree

from jnpr.junos import Device
from jnpr.junos.utils.config import Config
from jnpr.junos.op.routes import RouteTable
from jnpr.junos.op.ethport import EthPortTable
from jnpr.junos.exception import *
from jnpr.junos.factory import loadyaml
import mysql.connector

def interface_table():
    user = 'netbot'
    passwd = 'fd38*M0i'
    #cnx = mysql.connector.connect(user='powercheck', password='buyg867tgf94rn',host='hicritical-cluster.cluster-clhdx2lki42e.eu-west-1.rds.amazonaws.com',database='powercheck',buffered=True)
    cnx = mysql.connector.connect(user='root', password='bgt567UJM',host='hidb.clhdx2lki42e.eu-west-1.rds.amazonaws.com',database='CWA',buffered=True)
    cursor = cnx.cursor()
    query = "SELECT name, switch_ip FROM CWA.BaseStations WHERE management != '1' or managment is null;"
    cursor.execute(query)
    datetime = time.strftime("%Y-%m-%d %H:%m")
    print(datetime)
    for c in cursor:
        Device.auto_probe = 5
        dev = Device(c[1],user=user,password=passwd)
        table = [['SwitchName','SwitchIp','Interface','Admin', 'Op', 'Description', 'MTU', 'Speed', 'Duplex', 'SnmpIndex', 'Flapped', 'Partner', 'PartnerSpeed']]
        try:
            dev.open()
            interfaces = dev.rpc.get_interface_information(extensive=True)
            interfaces = xmltodict.parse(etree.tostring(interfaces))
            interfaces = interfaces['interface-information']['physical-interface']
            try:
                cursor2 = cnx.cursor()
                query2 = "DELETE FROM powercheck.Interfaces WHERE SwitchName = %s"
                cursor2.execute(query2, (c[0],))
                cnx.commit()
                cursor2.close()
            except mysql.connector.Error as err:
                print(err)
           
            for i in interfaces:
                items = i.items()
                name = 'NULL'
                admin_status = 'NULL'
                oper_status = 'NULL'
                snmp_index = 'NULL'
                description = 'NULL'
                mtu = 'NULL'
                speed = 'NULL'
                flapped = "NULL"
                for j in items:
                    if j[0]=='name':
                        name = j[1]
                    if j[0]=='admin-status':
                        admin_status = j[1].items()[1][1]
                    if j[0]=='oper-status':
                        oper_status = j[1]
                    if j[0]=='snmp-index':
                        snmp_index = j[1]
                    if j[0]=='description':
                        description = j[1]
                    if j[0]=='mtu':
                        mtu = j[1]
                    if j[0]=='speed':
                        speed = j[1]
                    if j[0]=='duplex':
                        duplex = j[1]
                    if j[0] == 'interface-flapped':
                        flapped = j[1].items()[1][1]
                        flapped =  flapped[:16]
                    if j[0] == 'ethernet-autonegotiation':
                        partner_autonegotiation = j[1].items()[0][1]
                        if partner_autonegotiation == 'complete':
                            partner_speed = j[1].items()[3][1]
                
                try:
                    data = (c[0], c[1], name, admin_status,oper_status, description, mtu, speed, duplex, snmp_index, flapped, partner_autonegotiation, partner_speed, datetime,)            
                    cursor3 = cnx.cursor()
                    query3 = "INSERT INTO powercheck.Interfaces(SwitchName, SwitchIp, Name, Admin, Op, Description, MTU, Speed, Duplex, SnmpIndex, Flapped, Partner, PartnerSpeed, LastUpdate) VALUES(%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)"
                    cursor3.execute(query3, data)
                    cnx.commit()
                    cursor3.close()
                    
                except mysql.connector.Error as err:
                    print(err)
                
                dev.close()
                table.append([c[0], c[1], name, admin_status,oper_status, description, mtu, speed, duplex, snmp_index, flapped, partner_autonegotiation, partner_speed])   
        except Exception as err:
                print('Couldn\'t connect to ' + c[1] + '...')
                print(err)

interface_table()